var mozless_enabled;
var mozless_debug;
var mozless_focusMode;
var mozless_emacskeys;

var mozless_sb;

var mozless_focusedFrameIndex;

var mozless_isFirefox = (mozless_getAppName() == "Firefox");


//mozless_init_settings(); // XXX moved in mozless_init()

function mozless_init_settings()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

  mozless_enabled = mozless_getBoolPref(prefs, "enabled", true);
  mozless_debug = mozless_getBoolPref(prefs, "debug", false);
  mozless_focusMode = mozless_getBoolPref(prefs, "focusmode", false);
  mozless_emacskeys = mozless_getBoolPref(prefs, "emacskeys", false);

	if (mozless_enabled && mozless_getAppName() != "Firefox") {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch);

		if (prefs.getBoolPref("accessibility.typeaheadfind.autostart") == true) {
			prefs.setBoolPref("accessibility.typeaheadfind.autostart", false);
			if (mozless_getAppName() != "Firefox")
				alert("mozless: "
					+ mozless_sb.GetStringFromName("autostart_is_suppressed")
					+ " (accessibility.typeaheadfind.autostart = false)");
		}
		if (prefs.getBoolPref("accessibility.typeaheadfind.linksonly") == true) {
			prefs.setBoolPref("accessibility.typeaheadfind.linksonly", false);
			alert("mozless: "
				+ mozless_sb.GetStringFromName("linksonly_is_suppressed")
				+ " (accessibility.typeaheadfind.linksonly = false)");
		}
	}
}

function mozless_init(e) {
  var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].
    getService(Components.interfaces.nsIStringBundleService);
  mozless_sb = sbs.createBundle("chrome://mozless/locale/messages.properties");

	mozless_init_settings(); // XXX

	if (window._content.frames.length > 0) {
		mozless_focusedFrameIndex = 0;
		window._content.frames[mozless_focusedFrameIndex].focus();
	} else {
		mozless_focusedFrameIndex = null;
	}
}

window.addEventListener("load", mozless_init, true);

function mozless_getBoolPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getBoolPref(name);
	else
		return d;
}

function mozless_getIntPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getIntPref(name);
	else
		return d;
}

function mozless_getCharPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getCharPref(name);
	else
		return d;
}

MozlessPrefsObserver.prototype =
{
  observe:
    function(subject, topic, data) {
      mozless_init_settings();
    }
}

var mozless_prefs_observer = new MozlessPrefsObserver();

function MozlessPrefsObserver()
{
  try {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
      .getService(Components.interfaces.nsIPrefService)
      .getBranch(null);
    var pbi = prefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    pbi.addObserver("extensions.mozless", this, false);
  } catch (e) {
    alert(e);
  }
}

function mozless_getAppName()
{
	var name = null;

	try {
		var info = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
		name = info.name;
	} catch (e) { }

	return name;
}

function mozless_finding()
{
	if (mozless_isFirefox) return !document.getElementById("FindToolbar").hidden;
	else return false;
}

function mozless_focusTop() {
  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i].offsetTop >= w.pageYOffset
	&& links[i].offsetTop < w.pageYOffset + w.innerHeight) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusBottom()
{
  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i].offsetTop < w.pageYOffset + w.innerHeight
	&& links[i].offsetTop >= w.pageYOffset) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusPrev() {
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusBottom();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusBottom();
  }
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i] == focus) {
      if (i-1 >= 0) {
	links[i-1].focus();
	links[i-1].select();
      }
      return;
    }
  }
}

function mozless_focusNext() {
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusTop();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusTop();
  }
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i] == focus) {
      if (i+1 < links.length) {
	links[i+1].focus();
	links[i+1].select();
      }
      return;
    }
  }
}

//--------------------------------------------------------------------

function mozless_function_focus_mode()
{
	if (mozless_finding()) return;

  mozless_focusMode = !mozless_focusMode;
}

function mozless_function_previous()
{
	if (mozless_finding()) return;

  if (mozless_focusMode) {
    mozless_focusPrev();
  } else {
    goDoCommand('cmd_scrollLineUp');
  }
}

function mozless_function_next()
{
	if (mozless_finding()) return;

  if (mozless_focusMode) {
    mozless_focusNext();
  } else {
    goDoCommand('cmd_scrollLineDown');
  }
}

function mozless_function_back()
{
	if (mozless_finding()) return;

  if (mozless_focusMode) {
    BrowserBack();
  } else {
    goDoCommand('cmd_scrollLeft');
  }
}

function mozless_followLink()
{
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) return;
  window._content.open(focus.href, "_self");
}

function mozless_function_forward()
{
	if (mozless_finding()) return;

  if (mozless_focusMode) {
    mozless_followLink();
  } else {
    goDoCommand('cmd_scrollRight');
  }
}

function mozless_function_page_up()
{
	if (mozless_finding()) return;

  goDoCommand('cmd_scrollPageUp');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_page_down()
{
	if (mozless_finding()) return;

  goDoCommand('cmd_scrollPageDown');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_half_page_up()
{
	if (mozless_finding()) return;

  var focus = document.commandDispatcher.focusedElement;
	if (focus == null) {
		if (mozless_focusedFrameIndex != null) {
			var w = window._content.frames[mozless_focusedFrameIndex]
				.document.defaultView;
			w.scrollBy(0, -w.innerHeight/2);
		} else if (window._content.frames.length > 0) {
			for (var i=0; i<window._content.frames.length; i++) {
				var w = window._content.frames[i].document.defaultView;
				w.scrollBy(0, -w.innerHeight/2);
			}
		} else {
			window._content.scrollBy(0, -window._content.innerHeight/2);
		}
	} else {
		var w = focus.ownerDocument.defaultView;
		w.scrollBy(0, -w.innerHeight/2);
	}

  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_half_page_down()
{
	if (mozless_finding()) return;

  var focus = document.commandDispatcher.focusedElement;
	if (focus == null) {
		if (mozless_focusedFrameIndex != null) {
			var w = window._content.frames[mozless_focusedFrameIndex]
				.document.defaultView;
			w.scrollBy(0, w.innerHeight/2);
		} else if (window._content.frames.length > 0) {
			for (var i=0; i<window._content.frames.length; i++) {
				var w = window._content.frames[i].document.defaultView;
				w.scrollBy(0, w.innerHeight/2);
			}
		} else {
			window._content.scrollBy(0, window._content.innerHeight/2);
		}
	} else {
		var w = focus.ownerDocument.defaultView;
		w.scrollBy(0, w.innerHeight/2);
	}

  if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_top()
{
	if (mozless_finding()) return;

  goDoCommand('cmd_scrollTop');
  if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_bottom()
{
	if (mozless_finding()) return;

  goDoCommand('cmd_scrollBottom');
  if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_open_bookmarks()
{
	if (mozless_finding()) return;

  var dirService = Components
    .classes['@mozilla.org/file/directory_service;1']
    .getService(Components.interfaces.nsIProperties);

  const NS_APP_USER_PROFILE_50_DIR = "ProfD";
  profileDir = dirService.get(NS_APP_USER_PROFILE_50_DIR, Components.interfaces.nsIFile);

  var bookmarksURL = "file://" + profileDir.path + "/bookmarks.html";
  window._content.open(bookmarksURL, "_self");
}

//
// w3m keys
//

function mozless_function_go_back()
{
	if (mozless_finding()) return;

  BrowserBack();
}

function mozless_function_go_forward()
{
	if (mozless_finding()) return;

  BrowserForward();
}

function mozless_function_reload()
{
	if (mozless_finding()) return;

  BrowserReload();
}

function mozless_function_stop()
{
	if (mozless_finding()) return;

  BrowserStop();
}

function mozless_function_home()
{
	if (mozless_finding()) return;

  BrowserHome();
}

function mozless_function_focus_url_bar()
{
	if (mozless_finding()) return;

  openLocation();
}

//
// common keys, again
//

function mozless_function_find_next()
{
	if (mozless_finding()) return;

  findNext();
}

function mozless_findPrevious()
{
  findPrevious();
}

function mozless_function_close()
{
	if (mozless_finding()) return;

  BrowserCloseTabOrWindow();
}

function mozless_function_close_window()
{
	if (mozless_finding()) return;

  BrowserCloseWindow();
}

//
// tab management keys
//

function mozless_function_new_tab()
{
	if (mozless_finding()) return;

  var homePage = gHomeButton.getHomePage();
  delayedOpenTab(homePage);
}

// NOTE: delta must be small :)
function mozless_tabRelativeSelect(delta)
{
  var oldTab = gBrowser.selectedTab;
  var newTab = null;
  var length = gBrowser.tabContainer.childNodes.length;
  var index;
  for (index=0; index<length; index++) {
    if (gBrowser.tabContainer.childNodes[index] == oldTab) {
      var new_index = index + delta;
      if (new_index < 0) new_index += length;
      else if (new_index >= length) new_index -= length;
      newTab = gBrowser.tabContainer.childNodes[new_index];
      break;
    }
  }
  if (newTab && newTab != oldTab)
    gBrowser.selectedTab = newTab;
}

function mozless_function_previous_tab()
{
	if (mozless_finding()) return;

  mozless_tabRelativeSelect(-1);
}

function mozless_function_next_tab()
{
	if (mozless_finding()) return;

  mozless_tabRelativeSelect(+1);
}

function mozless_function_open_tab()
{
	if (mozless_finding()) return;

  var focus = document.commandDispatcher.focusedElement;
  if (!focus) return;
  gBrowser.selectedTab = gBrowser.addTab(focus.href);
}

function mozless_function_previous_frame()
{
	if (mozless_finding()) return;

	if (window._content.frames.length > 0) {
		if (mozless_focusedFrameIndex == null) {
			mozless_focusedFrameIndex = 0;
		} else {
			mozless_focusedFrameIndex--;
			if (mozless_focusedFrameIndex < 0)
				mozless_focusedFrameIndex = window._content.frames.length - 1;
		}
		window._content.frames[mozless_focusedFrameIndex].focus();
	}
}

function mozless_function_next_frame()
{
	if (mozless_finding()) return;

	if (window._content.frames.length > 0) {
		if (mozless_focusedFrameIndex == null) {
			mozless_focusedFrameIndex = 0;
		} else {
			mozless_focusedFrameIndex++;
			if (mozless_focusedFrameIndex >= window._content.frames.length)
				mozless_focusedFrameIndex = 0;
		}
		window._content.frames[mozless_focusedFrameIndex].focus();
	}
}

// mozless keys

function mozless_key_o()
{
	if (mozless_enabled) mozless_function_focus_mode();
}

function mozless_key_k()
{
	if (mozless_enabled) mozless_function_previous();
}

function mozless_key_j()
{
	if (mozless_enabled) mozless_function_next();
}

function mozless_key_h()
{
	if (mozless_enabled) mozless_function_back();
}

function mozless_key_l()
{
	if (mozless_enabled) mozless_function_forward();
}

function mozless_key_u()
{
	if (mozless_enabled) mozless_function_half_page_up();
}

function mozless_key_i()
{
	if (mozless_enabled) mozless_function_half_page_down();
}

// less keys

function mozless_key_b()
{
	if (mozless_enabled) mozless_function_page_up();
}

function mozless_key_f()
{
	if (mozless_enabled) mozless_function_page_down();
}

function mozless_key_space()
{
	if (mozless_enabled) mozless_function_page_down();
	else goDoCommand('cmd_scrollPageDown');
}

function mozless_key_d()
{
	if (mozless_enabled) mozless_function_half_page_down();
}

function mozless_key_g()
{
	if (mozless_enabled) mozless_function_top();
}

function mozless_key_shift_g()
{
	if (mozless_enabled) mozless_function_bottom();
}

// Emacs keys

// NOTE: most *Browser*() functions are in the Firefox Source:
// mozilla/browser/base/content/browser.js

function mozless_key_control_p()
{
	if (mozless_enabled && mozless_emacskeys) mozless_function_previous();
  else PrintUtils.print(); //XXX ??
}

function mozless_key_control_n()
{
	if (mozless_enabled && mozless_emacskeys) mozless_function_next();
  else OpenBrowserWindow();
}

function mozless_key_control_b()
{
	if (mozless_enabled && mozless_emacskeys) mozless_function_back();
  else toggleSidebar('viewBookmarksSidebar');
}

function mozless_key_control_f()
{
	if (mozless_enabled && mozless_emacskeys) mozless_function_forward();
  else {
    openFindBar(); // not focused nor selected!!
    selectFindBar();
    // NOTE: *FindBar() functions are in the Firebird source:
    // mozilla/toolkit/components/typeaheadfind/content/findBar.js
  }
}

function mozless_key_control_j()
{
	if (mozless_enabled && mozless_emacskeys) mozless_function_next();
  //else BrowserPageInfo(); //XXX ??
}

function mozless_key_control_v()
{
	if (mozless_enabled && mozless_emacskeys) mozless_function_page_down();
}

// lynx keys

function mozless_key_up()
{
	if (mozless_enabled) mozless_function_previous();
	else goDoCommand('cmd_scrollLineUp');
}

function mozless_key_down()
{
	if (mozless_enabled) mozless_function_next();
	else goDoCommand('cmd_scrollLineDown');
}

function mozless_key_left()
{
	if (mozless_enabled) mozless_function_back();
	else goDoCommand('cmd_scrollLeft');
}

function mozless_key_right()
{
	if (mozless_enabled) mozless_function_forward();
	else goDoCommand('cmd_scrollRight');
}

function mozless_key_home()
{
	if (mozless_enabled) mozless_function_top();
	else goDoCommand('cmd_scrollTop');
}

function mozless_key_end()
{
	if (mozless_enabled) mozless_function_bottom();
	else goDoCommand('cmd_scrollBottom');
}

function mozless_key_page_up()
{
	if (mozless_enabled) mozless_function_page_up();
	else goDoCommand('cmd_scrollPageUp');
}

function mozless_key_page_down()
{
	if (mozless_enabled) mozless_function_page_down();
	else goDoCommand('cmd_scrollPageDown');
}

function mozless_key_v()
{
	if (mozless_enabled) mozless_function_open_bookmarks();
}

// w3m keys

function mozless_key_shift_b()
{
	if (mozless_enabled) mozless_function_go_back();
}

function mozless_key_shift_f()
{
	if (mozless_enabled) mozless_function_go_forward();
}

function mozless_key_shift_r()
{
	if (mozless_enabled) mozless_function_reload();
}

function mozless_key_shift_s()
{
	if (mozless_enabled) mozless_function_stop();
}

function mozless_key_shift_h()
{
	if (mozless_enabled) mozless_function_home();
}

function mozless_key_shift_u()
{
	if (mozless_enabled) mozless_function_focus_url_bar();
}

// common keys, again

function mozless_key_n()
{
	if (mozless_enabled) mozless_function_find_next();
}

function mozless_key_shift_n()
{
	if (mozless_enabled) mozless_findPrevious();
}

function mozless_key_q()
{
	if (mozless_enabled) mozless_function_close();
}

function mozless_key_shift_q()
{
	if (mozless_enabled) mozless_function_close_window();
}

// tab management keys

function mozless_key_t()
{
	if (mozless_enabled) mozless_function_new_tab();
}

function mozless_key_m()
{
	if (mozless_enabled) mozless_function_previous_tab();
}

function mozless_key_comma()
{
	if (mozless_enabled) mozless_function_next_tab();
}

function mozless_key_dot()
{
	if (mozless_enabled) mozless_function_open_tab();
}

// frame management keys

function mozless_key_w()
{
	if (mozless_enabled) mozless_function_previous_frame();
}

function mozless_key_e()
{
	if (mozless_enabled) mozless_function_next_frame();
}

// setting menu for Mozilla Suite

function mozless_settings()
{
	var dialog = window.openDialog("chrome://mozless/content/mozlessPrefDialog.xul",
		null, "modal, centerscreen");
}
